#include "Common.h"

#define SPEEDTAXI 4

private ["_start", "_end", "_plane", "_nimspots", "_plane",
   "_taxi", "_taxis", "_stop", "_taxi2", "_pos", "_dir", "_grp",
   "_locs", "_path", "_leg", "_v", "_i", "_pb",
   "_catEnd", "_fnc_rotate", "_fnc_rotateDir", "_nim"];

_nim = [_this, 0, ObjNull] call BIS_fnc_param;
_plane = [_this, 1, ObjNull] call BIS_fnc_param;
_start = [_this, 2, "E1"] call BIS_fnc_param;
_end = [_this, 3, "C1"] call BIS_fnc_param;

_nimspots = _nim getVariable "nimspots";

_locs = [] call TeTeT_fnc_initLoc;
_path = [_locs, _start, _end] call TeTeT_fnc_findPath;

_leg = _path select 0;
_taxis = [_leg select 3, _leg select 1];
_leg = _path select 1;
_taxis = _taxis + [_leg select 1, _leg select 3];

_fnc_rotateDir = {
  private ["_plane", "_dir", "_planeDir", "_turnDir"];
  _plane = _this select 0;
  _dir = _this select 1;
  _plane setVelocity [0, 0, 0];
  [format ["Turning %1", _dir]] call TeTeT_fnc_debug;
  if (_dir > 180) then {
    _dir = (360 - _dir) * -1;
  };
  if (_dir > 0) then {
    _turnDir = 1;
  } else {
    _turnDir = -1;
  };
  format ["Now Turning %1 with %2", _dir, _turnDir] call TeTeT_fnc_debug;
  _dir = abs _dir;
  while {_dir >= 0} do {
    _planeDir = (getDir _plane) + _turnDir;
    _plane setDir _planeDir;
    _dir = _dir - 1;
    sleep 0.025;
  };
  _plane setVelocity [0, 0, 0];
};

_fnc_rotate = {
  private ["_plane", "_dest", "_dir", "_v"];
  _plane = _this select 0;
  _dest = _this select 1;
  _dir = [_plane, _dest] call BIS_fnc_RelativeDirTo;
  [_plane, _dir] call _fnc_rotateDir;
};

{

  private _pos = _x;
  [_plane, _pos, _plane getDir _pos, 0] call _fnc_rotate;
  // _plane setDir (_plane getDir _pos);
  while {alive player and alive _plane and _plane distance _pos > 3} do {
    private _pos2 = _plane getPos [1, getDir _plane];
    // not sure why this has to be 5, but anything less and the plane dives into the ground
    _pos2 set [2, getPosASL _plane # 2];
    _plane setVelocityTransformation
    [
      getPosASL _plane,
      _pos2,
      [0, 0, 0],
      [0, 0, 0],
      vectorDir _plane,
      vectorDir _plane,
      [0, 0, 1],
      [0, 0, 1],
      0.1
    ];
    sleep 0.02;
  };

} forEach _taxis;

sleep 1;
// should be isolated
_plane setVelocity [0,0,0];

if (_end == "C1" or _end == "C2" or _end == "C3") then {
  _plane animate ["l_wingfold",0];
  _plane animate ["r_wingfold",0];
  _catEnd = format ["%1T", _end];
  _pos = _nimspots modelToWorld (_nimspots selectionPosition _catEnd);
  _dir = [_plane, _pos] call BIS_fnc_dirTo;
  [_plane, _pos] call _fnc_rotate;
  _plane setDir _dir;
  [_plane, 0, 0] call BIS_fnc_setPitchBank;
};

if (_end == "E4") then {
  _dir = getDir _nimspots + 90;
  [_plane, _dir] call _fnc_rotateDir;
};

_plane;
